# Source code for azure.mgmt.datalake.analytics.account.operations.storage_accounts_operations

    # coding=utf-8
    # --------------------------------------------------------------------------
    # Copyright (c) Microsoft Corporation. All rights reserved.
    # Licensed under the MIT License. See License.txt in the project root for
    # license information.
    #
    # Code generated by Microsoft (R) AutoRest Code Generator.
    # Changes may cause incorrect behavior and will be lost if the code is
    # regenerated.
    # --------------------------------------------------------------------------

    import uuid
    from msrest.pipeline import ClientRawResponse
    from msrestazure.azure_exceptions import CloudError

    from .. import models

    class StorageAccountsOperations(object):
        """StorageAccountsOperations operations.

        :param client: Client for service requests.
        :param config: Configuration of service client.
        :param serializer: An object model serializer.
        :param deserializer: An object model deserializer.
        :ivar api_version: Client Api Version. Constant value: "2016-11-01".
        """

        models = models

        def __init__(self, client, config, serializer, deserializer):

            self._client = client
            self._serialize = serializer
            self._deserialize = deserializer
            self.api_version = "2016-11-01"

            self.config = config

        def list_by_account(
                self, resource_group_name, account_name, filter=None, top=None, skip=None, select=None, orderby=None, count=None, custom_headers=None, raw=False, **operation_config):
            """Gets the first page of Azure Storage accounts, if any, linked to the
            specified Data Lake Analytics account. The response includes a link to
            the next page, if any.

            :param resource_group_name: The name of the Azure resource group.
            :type resource_group_name: str
            :param account_name: The name of the Data Lake Analytics account.
            :type account_name: str
            :param filter: The OData filter. Optional.
            :type filter: str
            :param top: The number of items to return. Optional.
            :type top: int
            :param skip: The number of items to skip over before returning
             elements. Optional.
            :type skip: int
            :param select: OData Select statement. Limits the properties on each
             entry to just those requested, e.g.
             Categories?$select=CategoryName,Description. Optional.
            :type select: str
            :param orderby: OrderBy clause. One or more comma-separated
             expressions with an optional "asc" (the default) or "desc" depending
             on the order you'd like the values sorted, e.g.
             Categories?$orderby=CategoryName desc. Optional.
            :type orderby: str
            :param count: The Boolean value of true or false to request a count of
             the matching resources included with the resources in the response,
             e.g. Categories?$count=true. Optional.
            :type count: bool
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: An iterator like instance of StorageAccountInformation
            :rtype:
             ~azure.mgmt.datalake.analytics.account.models.StorageAccountInformationPaged[~azure.mgmt.datalake.analytics.account.models.StorageAccountInformation]
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            def internal_paging(next_link=None, raw=False):

                if not next_link:
                    # Construct URL
                    url = self.list_by_account.metadata['url']
                    path_format_arguments = {
                        'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str'),
                        'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                        'accountName': self._serialize.url("account_name", account_name, 'str')
                    }
                    url = self._client.format_url(url, **path_format_arguments)

                    # Construct parameters
                    query_parameters = {}
                    if filter is not None:
                        query_parameters['$filter'] = self._serialize.query("filter", filter, 'str')
                    if top is not None:
                        query_parameters['$top'] = self._serialize.query("top", top, 'int', minimum=1)
                    if skip is not None:
                        query_parameters['$skip'] = self._serialize.query("skip", skip, 'int', minimum=1)
                    if select is not None:
                        query_parameters['$select'] = self._serialize.query("select", select, 'str')
                    if orderby is not None:
                        query_parameters['$orderby'] = self._serialize.query("orderby", orderby, 'str')
                    if count is not None:
                        query_parameters['$count'] = self._serialize.query("count", count, 'bool')
                    query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

                else:
                    url = next_link
                    query_parameters = {}

                # Construct headers
                header_parameters = {}
                header_parameters['Content-Type'] = 'application/json; charset=utf-8'
                if self.config.generate_client_request_id:
                    header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
                if custom_headers:
                    header_parameters.update(custom_headers)
                if self.config.accept_language is not None:
                    header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

                # Construct and send request
                request = self._client.get(url, query_parameters)
                response = self._client.send(
                    request, header_parameters, stream=False, **operation_config)

                if response.status_code not in [200]:
                    exp = CloudError(response)
                    exp.request_id = response.headers.get('x-ms-request-id')
                    raise exp

                return response

            # Deserialize response
            deserialized = models.StorageAccountInformationPaged(internal_paging, self._deserialize.dependencies)

            if raw:
                header_dict = {}
                client_raw_response = models.StorageAccountInformationPaged(internal_paging, self._deserialize.dependencies, header_dict)
                return client_raw_response

            return deserialized
        list_by_account.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeAnalytics/accounts/{accountName}/storageAccounts'}

        def add(
                self, resource_group_name, account_name, storage_account_name, access_key, suffix=None, custom_headers=None, raw=False, **operation_config):
            """Updates the specified Data Lake Analytics account to add an Azure
            Storage account.

            :param resource_group_name: The name of the Azure resource group.
            :type resource_group_name: str
            :param account_name: The name of the Data Lake Analytics account.
            :type account_name: str
            :param storage_account_name: The name of the Azure Storage account to
             add
            :type storage_account_name: str
            :param access_key: The access key associated with this Azure Storage
             account that will be used to connect to it.
            :type access_key: str
            :param suffix: The optional suffix for the storage account.
            :type suffix: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: None or ClientRawResponse if raw=true
            :rtype: None or ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            parameters = models.AddStorageAccountParameters(access_key=access_key, suffix=suffix)

            # Construct URL
            url = self.add.metadata['url']
            path_format_arguments = {
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str'),
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                'accountName': self._serialize.url("account_name", account_name, 'str'),
                'storageAccountName': self._serialize.url("storage_account_name", storage_account_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

            # Construct headers
            header_parameters = {}
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            body_content = self._serialize.body(parameters, 'AddStorageAccountParameters')

            # Construct and send request
            request = self._client.put(url, query_parameters)
            response = self._client.send(
                request, header_parameters, body_content, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            if raw:
                client_raw_response = ClientRawResponse(None, response)
                return client_raw_response
        add.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeAnalytics/accounts/{accountName}/storageAccounts/{storageAccountName}'}

        def get(
                self, resource_group_name, account_name, storage_account_name, custom_headers=None, raw=False, **operation_config):
            """Gets the specified Azure Storage account linked to the given Data Lake
            Analytics account.

            :param resource_group_name: The name of the Azure resource group.
            :type resource_group_name: str
            :param account_name: The name of the Data Lake Analytics account.
            :type account_name: str
            :param storage_account_name: The name of the Azure Storage account for
             which to retrieve the details.
            :type storage_account_name: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: StorageAccountInformation or ClientRawResponse if raw=true
            :rtype:
             ~azure.mgmt.datalake.analytics.account.models.StorageAccountInformation
             or ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.get.metadata['url']
            path_format_arguments = {
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str'),
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                'accountName': self._serialize.url("account_name", account_name, 'str'),
                'storageAccountName': self._serialize.url("storage_account_name", storage_account_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

            # Construct headers
            header_parameters = {}
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.get(url, query_parameters)
            response = self._client.send(request, header_parameters, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            deserialized = None

            if response.status_code == 200:
                deserialized = self._deserialize('StorageAccountInformation', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        get.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeAnalytics/accounts/{accountName}/storageAccounts/{storageAccountName}'}

        def update(
                self, resource_group_name, account_name, storage_account_name, access_key=None, suffix=None, custom_headers=None, raw=False, **operation_config):
            """Updates the Data Lake Analytics account to replace Azure Storage blob
            account details, such as the access key and/or suffix.

            :param resource_group_name: The name of the Azure resource group.
            :type resource_group_name: str
            :param account_name: The name of the Data Lake Analytics account.
            :type account_name: str
            :param storage_account_name: The Azure Storage account to modify
            :type storage_account_name: str
            :param access_key: The updated access key associated with this Azure
             Storage account that will be used to connect to it.
            :type access_key: str
            :param suffix: The optional suffix for the storage account.
            :type suffix: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: None or ClientRawResponse if raw=true
            :rtype: None or ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            parameters = None
            if access_key is not None or suffix is not None:
                parameters = models.UpdateStorageAccountParameters(access_key=access_key, suffix=suffix)

            # Construct URL
            url = self.update.metadata['url']
            path_format_arguments = {
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str'),
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                'accountName': self._serialize.url("account_name", account_name, 'str'),
                'storageAccountName': self._serialize.url("storage_account_name", storage_account_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

            # Construct headers
            header_parameters = {}
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            if parameters is not None:
                body_content = self._serialize.body(parameters, 'UpdateStorageAccountParameters')
            else:
                body_content = None

            # Construct and send request
            request = self._client.patch(url, query_parameters)
            response = self._client.send(
                request, header_parameters, body_content, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            if raw:
                client_raw_response = ClientRawResponse(None, response)
                return client_raw_response
        update.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeAnalytics/accounts/{accountName}/storageAccounts/{storageAccountName}'}

        def delete(
                self, resource_group_name, account_name, storage_account_name, custom_headers=None, raw=False, **operation_config):
            """Updates the specified Data Lake Analytics account to remove an Azure
            Storage account.

            :param resource_group_name: The name of the Azure resource group.
            :type resource_group_name: str
            :param account_name: The name of the Data Lake Analytics account.
            :type account_name: str
            :param storage_account_name: The name of the Azure Storage account to
             remove
            :type storage_account_name: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: None or ClientRawResponse if raw=true
            :rtype: None or ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.delete.metadata['url']
            path_format_arguments = {
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str'),
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                'accountName': self._serialize.url("account_name", account_name, 'str'),
                'storageAccountName': self._serialize.url("storage_account_name", storage_account_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

            # Construct headers
            header_parameters = {}
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.delete(url, query_parameters)
            response = self._client.send(request, header_parameters, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            if raw:
                client_raw_response = ClientRawResponse(None, response)
                return client_raw_response
        delete.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeAnalytics/accounts/{accountName}/storageAccounts/{storageAccountName}'}

        def list_storage_containers(
                self, resource_group_name, account_name, storage_account_name, custom_headers=None, raw=False, **operation_config):
            """Lists the Azure Storage containers, if any, associated with the
            specified Data Lake Analytics and Azure Storage account combination.
            The response includes a link to the next page of results, if any.

            :param resource_group_name: The name of the Azure resource group.
            :type resource_group_name: str
            :param account_name: The name of the Data Lake Analytics account.
            :type account_name: str
            :param storage_account_name: The name of the Azure storage account
             from which to list blob containers.
            :type storage_account_name: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: An iterator like instance of StorageContainer
            :rtype:
             ~azure.mgmt.datalake.analytics.account.models.StorageContainerPaged[~azure.mgmt.datalake.analytics.account.models.StorageContainer]
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            def internal_paging(next_link=None, raw=False):

                if not next_link:
                    # Construct URL
                    url = self.list_storage_containers.metadata['url']
                    path_format_arguments = {
                        'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str'),
                        'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                        'accountName': self._serialize.url("account_name", account_name, 'str'),
                        'storageAccountName': self._serialize.url("storage_account_name", storage_account_name, 'str')
                    }
                    url = self._client.format_url(url, **path_format_arguments)

                    # Construct parameters
                    query_parameters = {}
                    query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

                else:
                    url = next_link
                    query_parameters = {}

                # Construct headers
                header_parameters = {}
                header_parameters['Content-Type'] = 'application/json; charset=utf-8'
                if self.config.generate_client_request_id:
                    header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
                if custom_headers:
                    header_parameters.update(custom_headers)
                if self.config.accept_language is not None:
                    header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

                # Construct and send request
                request = self._client.get(url, query_parameters)
                response = self._client.send(
                    request, header_parameters, stream=False, **operation_config)

                if response.status_code not in [200]:
                    exp = CloudError(response)
                    exp.request_id = response.headers.get('x-ms-request-id')
                    raise exp

                return response

            # Deserialize response
            deserialized = models.StorageContainerPaged(internal_paging, self._deserialize.dependencies)

            if raw:
                header_dict = {}
                client_raw_response = models.StorageContainerPaged(internal_paging, self._deserialize.dependencies, header_dict)
                return client_raw_response

            return deserialized
        list_storage_containers.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeAnalytics/accounts/{accountName}/storageAccounts/{storageAccountName}/containers'}

        def get_storage_container(
                self, resource_group_name, account_name, storage_account_name, container_name, custom_headers=None, raw=False, **operation_config):
            """Gets the specified Azure Storage container associated with the given
            Data Lake Analytics and Azure Storage accounts.

            :param resource_group_name: The name of the Azure resource group.
            :type resource_group_name: str
            :param account_name: The name of the Data Lake Analytics account.
            :type account_name: str
            :param storage_account_name: The name of the Azure storage account
             from which to retrieve the blob container.
            :type storage_account_name: str
            :param container_name: The name of the Azure storage container to
             retrieve
            :type container_name: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: StorageContainer or ClientRawResponse if raw=true
            :rtype: ~azure.mgmt.datalake.analytics.account.models.StorageContainer
             or ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.get_storage_container.metadata['url']
            path_format_arguments = {
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str'),
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                'accountName': self._serialize.url("account_name", account_name, 'str'),
                'storageAccountName': self._serialize.url("storage_account_name", storage_account_name, 'str'),
                'containerName': self._serialize.url("container_name", container_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

            # Construct headers
            header_parameters = {}
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.get(url, query_parameters)
            response = self._client.send(request, header_parameters, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            deserialized = None

            if response.status_code == 200:
                deserialized = self._deserialize('StorageContainer', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        get_storage_container.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeAnalytics/accounts/{accountName}/storageAccounts/{storageAccountName}/containers/{containerName}'}

        def list_sas_tokens(
                self, resource_group_name, account_name, storage_account_name, container_name, custom_headers=None, raw=False, **operation_config):
            """Gets the SAS token associated with the specified Data Lake Analytics
            and Azure Storage account and container combination.

            :param resource_group_name: The name of the Azure resource group.
            :type resource_group_name: str
            :param account_name: The name of the Data Lake Analytics account.
            :type account_name: str
            :param storage_account_name: The name of the Azure storage account for
             which the SAS token is being requested.
            :type storage_account_name: str
            :param container_name: The name of the Azure storage container for
             which the SAS token is being requested.
            :type container_name: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: An iterator like instance of SasTokenInformation
            :rtype:
             ~azure.mgmt.datalake.analytics.account.models.SasTokenInformationPaged[~azure.mgmt.datalake.analytics.account.models.SasTokenInformation]
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            def internal_paging(next_link=None, raw=False):

                if not next_link:
                    # Construct URL
                    url = self.list_sas_tokens.metadata['url']
                    path_format_arguments = {
                        'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str'),
                        'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                        'accountName': self._serialize.url("account_name", account_name, 'str'),
                        'storageAccountName': self._serialize.url("storage_account_name", storage_account_name, 'str'),
                        'containerName': self._serialize.url("container_name", container_name, 'str')
                    }
                    url = self._client.format_url(url, **path_format_arguments)

                    # Construct parameters
                    query_parameters = {}
                    query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

                else:
                    url = next_link
                    query_parameters = {}

                # Construct headers
                header_parameters = {}
                header_parameters['Content-Type'] = 'application/json; charset=utf-8'
                if self.config.generate_client_request_id:
                    header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
                if custom_headers:
                    header_parameters.update(custom_headers)
                if self.config.accept_language is not None:
                    header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

                # Construct and send request
                request = self._client.post(url, query_parameters)
                response = self._client.send(
                    request, header_parameters, stream=False, **operation_config)

                if response.status_code not in [200]:
                    exp = CloudError(response)
                    exp.request_id = response.headers.get('x-ms-request-id')
                    raise exp

                return response

            # Deserialize response
            deserialized = models.SasTokenInformationPaged(internal_paging, self._deserialize.dependencies)

            if raw:
                header_dict = {}
                client_raw_response = models.SasTokenInformationPaged(internal_paging, self._deserialize.dependencies, header_dict)
                return client_raw_response

            return deserialized
        list_sas_tokens.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeAnalytics/accounts/{accountName}/storageAccounts/{storageAccountName}/containers/{containerName}/listSasTokens'}